/*
 *  Project: LKH - lect3
 *  File: es1.c
 *  Date: 01/24/2006
 *  Author. R. Gioiosa
 */

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <asm/uaccess.h>
#include <linux/proc_fs.h>

#define MODULE_VERS "1.0"
#define MODULE_NAME "LKH-ES2"

#define DEBUG_ON

#ifdef DEBUG_ON
#define Dprintk(ARG...) printk(KERN_DEBUG MODULE_NAME ": " ARG)
#else
#define Dprintk(ARG...) 
#endif

static struct proc_dir_entry* lkh_pde;

static int __init es2_init(void)
{
  lkh_pde = proc_mkdir("lkh",NULL);
  if(!lkh_pde)
    {
      printk(KERN_ERR "%s: error creating proc_dir_entry!\n",MODULE_NAME);
      return -1;
    }
  Dprintk("proc dir created\n");
  Dprintk("module loaded\n");
  return 0;
}

static void __exit es2_exit(void)
{
  remove_proc_entry("lkh",NULL);
  Dprintk("proc dir removed\n");
  Dprintk("module unloaded\n");
}

module_init(es2_init);
module_exit(es2_exit);

MODULE_AUTHOR("Roberto Gioiosa");
MODULE_DESCRIPTION("Linux Kernel Hacking 06 - Es2");
MODULE_LICENSE("GPL");
MODULE_VERSION(MODULE_VERS);
